<?php

class ControllerExtensionPaymentVerifoneHosted extends Controller
{
    private $error = [];
    /**
     * name of the payment method`
     */
    const NAME = 'payment_verifone_hosted';

    /**
     * returns the settings view
     */
    public function index()
    {
        $this->load->language('extension/payment/verifone_hosted');
        $this->document->setTitle($this->language->get('heading_title'));
        $this->load->model('setting/setting');
        $this->load->model('localisation/order_status');
        $this->load->model('localisation/geo_zone');

        $post_data = $this->request->post;

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('payment_verifone_hosted', $post_data);
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
        }

        $data['error_warning'] = isset($this->error['warning']) ? $this->error['warning'] : '';
        $data['errors'] = isset($this->error['errors']) ? $this->error['errors'] : [];

        $data['breadcrumbs'] = [
            [
                'text' => $this->language->get('text_home'),
                'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
            ],
            [
                'text' => $this->language->get('text_extension'),
                'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
            ],
            [
                'text' => $this->language->get('heading_title'),
                'href' => $this->url->link('extension/payment/verifone', 'user_token=' . $this->session->data['user_token'], true)
            ]
        ];

        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
        $data['action'] = $this->url->link('extension/payment/verifone_hosted', 'user_token=' . $this->session->data['user_token'], true);
        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);
        $data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

        $data[self::NAME . '_status'] = isset($post_data[self::NAME . '_status']) ?
            $post_data[self::NAME . '_status'] : $this->config->get(self::NAME . '_status');

        $data[self::NAME . '_test'] = isset($post_data[self::NAME . '_test']) ?
            $post_data[self::NAME . '_test'] : $this->config->get(self::NAME . '_test');

        $data[self::NAME . '_total'] = isset($post_data[self::NAME . '_total']) ?
            $post_data[self::NAME . '_total'] : $this->config->get(self::NAME . '_total');

        $data[self::NAME . '_order_status_id'] = isset($post_data[self::NAME . '_order_status_id']) ?
            $post_data[self::NAME . '_order_status_id'] : $this->config->get(self::NAME . '_order_status_id');

        $data[self::NAME . '_geo_zone_id'] = isset($post_data[self::NAME . '_geo_zone_id']) ?
            $post_data[self::NAME . '_geo_zone_id'] : $this->config->get(self::NAME . '_geo_zone_id');

        $data[self::NAME . '_region'] = isset($post_data[self::NAME . '_region']) ?
            $post_data[self::NAME . '_region'] : $this->config->get(self::NAME . '_region');

        $data[self::NAME . '_prod_api_user'] = isset($post_data[self::NAME . '_prod_api_user']) ?
            $post_data[self::NAME . '_prod_api_user'] : $this->config->get(self::NAME . '_prod_api_user');

        $data[self::NAME . '_prod_api_key'] = isset($post_data[self::NAME . '_prod_api_key']) ?
            $post_data[self::NAME . '_prod_api_key'] : $this->config->get(self::NAME . '_prod_api_key');

        $data[self::NAME . '_prod_entity'] = isset($post_data[self::NAME . '_prod_entity']) ?
            $post_data[self::NAME . '_prod_entity'] : $this->config->get(self::NAME . '_prod_entity');

        $data[self::NAME . '_prod_contract'] = isset($post_data[self::NAME . '_prod_contract']) ?
            $post_data[self::NAME . '_prod_contract'] : $this->config->get(self::NAME . '_prod_contract');

        $data[self::NAME . '_prod_3ds_contract'] = isset($post_data[self::NAME . '_prod_3ds_contract']) ?
            $post_data[self::NAME . '_prod_3ds_contract'] : $this->config->get(self::NAME . '_prod_3ds_contract');

        $data[self::NAME . '_test_api_user'] = isset($post_data[self::NAME . '_test_api_user']) ?
            $post_data[self::NAME . '_test_api_user'] : $this->config->get(self::NAME . '_test_api_user');

        $data[self::NAME . '_test_api_key'] = isset($post_data[self::NAME . '_test_api_key']) ?
            $post_data[self::NAME . '_test_api_key'] : $this->config->get(self::NAME . '_test_api_key');

        $data[self::NAME . '_test_entity'] = isset($post_data[self::NAME . '_test_entity']) ?
            $post_data[self::NAME . '_test_entity'] : $this->config->get(self::NAME . '_test_entity');

        $data[self::NAME . '_test_contract'] = isset($post_data[self::NAME . '_test_contract']) ?
            $post_data[self::NAME . '_test_contract'] : $this->config->get(self::NAME . '_test_contract');

        $data[self::NAME . '_test_3ds_contract'] = isset($post_data[self::NAME . '_test_3ds_contract']) ?
            $post_data[self::NAME . '_test_3ds_contract'] : $this->config->get(self::NAME . '_test_3ds_contract');

        $data[self::NAME . '_3ds'] = isset($post_data[self::NAME . '_3ds']) ?
            $post_data[self::NAME . '_3ds'] : $this->config->get(self::NAME . '_3ds');

        $data[self::NAME . '_cvv'] = isset($post_data[self::NAME . '_cvv']) ?
            $post_data[self::NAME . '_cvv'] : $this->config->get(self::NAME . '_cvv');

        $data[self::NAME . '_curl'] = isset($post_data[self::NAME . '_curl']) ?
            $post_data[self::NAME . '_curl'] : $this->config->get(self::NAME . '_curl');

        $data[self::NAME . '_overlay'] = isset($post_data[self::NAME . '_overlay']) ?
            $post_data[self::NAME . '_overlay'] : $this->config->get(self::NAME . '_overlay');

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/verifone_hosted', $data));
    }

    /**
     * validates the Save post request
     * @return bool
     */
    protected function validate()
    {
        if (!$this->user->hasPermission('modify', 'extension/payment/verifone_hosted')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }
        $except = [self::NAME . '_test_3ds_contract', self::NAME . '_prod_3ds_contract'];
        $post_data = $this->request->post;
        foreach ($post_data as $key => $item) {

            // all fields from test/prod tabs are required
            if (strpos($key, 'payment_verifone_hosted_prod_') !== false ||
                strpos($key, 'payment_verifone_hosted_test_') !== false) {
                if (!$item || $item === '') {
                    if (!in_array($key, $except)) {
                        $lang_key = str_replace('payment_verifone_hosted_', 'entry_', $key);
                        $this->error['errors'][] = $this->language->get($lang_key) . $this->language->get('error_required_field');
                    }
                }
            }
        }

        return !$this->error;
    }

    /**
     * install the payment module
     */
    public function install()
    {
        $this->load->model('extension/payment/verifone_hosted');

        $this->model_extension_payment_verifone_hosted->install();
    }

    /**
     * uninstall the payment module
     */
    public function uninstall()
    {
        $this->load->model('extension/payment/verifone_hosted');

        $this->model_extension_payment_verifone_hosted->uninstall();
    }

    /**
     * refunds an order
     */
    public function refund()
    {
        //default response
        $response = ['success' => false, 'message' => 'Missing data'];

        if (isset($this->request->post['order_id']) && !empty($this->request->post['order_id']) &&
            isset($this->request->post['amount']) && !empty($this->request->post['amount'])) {
            $this->load->model('extension/payment/verifone_hosted');
            $response = $this->model_extension_payment_verifone_hosted->refund(
                $this->request->post['order_id'],
                $this->request->post['amount'],
                $this->request->post['comment']
            );
        }
        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($response));
    }


    /**
     * @return mixed
     * @throws \Exception
     */
    public function order()
    {
        $this->load->language('extension/payment/verifone_hosted');
        $this->load->model('extension/payment/verifone_hosted');
        $this->load->model('sale/order');

        $order = $this->model_sale_order->getOrder($this->request->get['order_id']);
        if ($this->config->get('payment_verifone_hosted_status') && $order['payment_code'] === 'verifone_hosted') {
            $transaction = $this->model_extension_payment_verifone_hosted->getTransactionByOrderId($order['order_id']);
            $available_amount = $transaction['amount'];
            if ($transaction['refunds']) {
                foreach ($transaction['refunds'] as $refund) {
                    if ($refund['verifone_refund_status'] === 'REFUNDED') {
                        $available_amount = $available_amount - $refund['amount_refunded'];
                    }
                }
            }
            $transaction['available_amount'] = round($available_amount,2);
            $transaction['amount_refunded'] = $transaction['amount'] - $available_amount;
            $data['text_refund'] = $this->language->get('text_refund');
            $data['text_total_amount_refund'] = $this->language->get('text_total_amount_refund');
            $data['text_refund_final'] = $this->language->get('text_refund_final');
            $data['order'] = $order;

            $data['order_total'] = $this->currency->format($order['total'], $order['currency_code'], '', false);
            $data['user_token'] = $this->session->data['user_token'];
            $data['transaction'] = $transaction;
            $data['action'] = $this->url->link('extension/payment/verifone_hosted/refund', 'user_token=' . $this->session->data['user_token'], true);
            $formattedStatus = str_replace('_', ' ', $data['transaction']['verifone_order_status']);
            $data['formatted_status'] = ($transaction['verifone_order_status'] === 'TRANSACTION_SUCCESS') ?
                '<b class="text-success">' . $formattedStatus . '</b>' :
                '<b class="text-danger">' . $formattedStatus . '</b>';

            return $this->load->view('extension/payment/verifone_hosted_order', $data);
        }
    }

}
